VERSION 5.00
Object = "{248DD890-BB45-11CF-9ABC-0080C7E7B78D}#1.0#0"; "mswinsck.ocx"
Begin VB.Form frmCliente 
   Caption         =   "Form1"
   ClientHeight    =   2070
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   6795
   LinkTopic       =   "Form1"
   ScaleHeight     =   2070
   ScaleWidth      =   6795
   StartUpPosition =   3  'Windows Default
   Begin VB.Timer Timer1 
      Interval        =   1000
      Left            =   5910
      Top             =   30
   End
   Begin MSWinsockLib.Winsock wskConexao 
      Left            =   6330
      Top             =   30
      _ExtentX        =   741
      _ExtentY        =   741
      _Version        =   393216
   End
   Begin VB.Label lblStatus 
      AutoSize        =   -1  'True
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   12
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   300
      Left            =   0
      TabIndex        =   1
      Top             =   300
      Width           =   90
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Status de conexo:"
      Height          =   225
      Left            =   30
      TabIndex        =   0
      Top             =   60
      Width           =   1380
   End
End
Attribute VB_Name = "frmCliente"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'Enums
Private Enum enTipoRetorno
    voltarTexto
    voltarPosicao
End Enum

Private Sub Form_Load()
    With wskConexao
        .RemoteHost = "anakin" 'Nome ou IP do servidor (pode ser o mesmo computador que o cliente)
        .RemotePort = 20001 'Porta de conexo com o servidor
        .Connect
    End With
End Sub

Private Sub Timer1_Timer()
    'Mostra o Status da conexo
    Select Case (wskConexao.State)
        Case sckConnected
            lblStatus.Caption = "Conectado com o Servidor"
        Case sckClosed, sckClosing
            lblStatus.Caption = "No conseguindo se conectar com o servidor"
    End Select
    If (wskConexao.State = sckError) Or _
       (wskConexao.State = sckClosed) Or _
       (wskConexao.State = sckClosing) Then
        'Tenta se conectar novamente
        wskConexao.Close
        wskConexao.Connect
    End If
End Sub

Private Sub wskConexao_DataArrival(ByVal bytesTotal As Long)
    'Recebe dados do servidor
    Dim protocolo As String
    Dim acao As String
    Dim mensagem As String
    
    'Pega os dados enviados do servidor
    wskConexao.GetData protocolo, vbString
    'Pega o cdigo da ao na mensagem
    acao = parseLine(protocolo, "~", 1)
    Select Case (acao)
        Case "1" 'Mostrar mensagem vinda do servidor
            'Pega o texto na mensagem
            mensagem = parseLine(protocolo, "~", 2)
            MsgBox mensagem, vbInformation, "Mensagem Servidor"
    End Select
End Sub

Private Sub wskConexao_Error(ByVal Number As Integer, Description As String, ByVal Scode As Long, ByVal Source As String, ByVal HelpFile As String, ByVal HelpContext As Long, CancelDisplay As Boolean)
    'Erro de conexo com o servidor
    lblStatus.Caption = "Erro ao se conectar com o servidor." & vbCrLf & _
                        "Cdigo: " & Number & vbCrLf & _
                        "Descrio: " & Description
End Sub

Private Function parseLine(ByRef texto As String, _
                           ByRef delimiter As String, _
                           ByRef token As Integer, _
                           Optional ByVal retorno As enTipoRetorno = voltarTexto) As String
    'Pega uma determinada parte de um texto dividido por separadores
    Dim i As Integer
    Dim j As Integer
    Dim buffer As String
    Dim posicao As Long

    j = 0
    buffer = texto

    Do While True
        i = InStr(buffer, delimiter)
        If (i > 0) Then
            posicao = (posicao + i)
            j = (j + 1)
            If (j = token) Then
                buffer = Mid(buffer, 1, i - 1)
                Exit Do
            ElseIf (i = 0) And (j > 0) And (j <> token) Then
                Exit Do
            Else
                buffer = Right(buffer, Len(buffer) - i)
            End If
        Else
            Exit Do
        End If
    Loop

    If (retorno = voltarTexto) Then
        parseLine = buffer
    Else
        parseLine = CStr(posicao)
    End If
End Function
