VERSION 5.00
Object = "{248DD890-BB45-11CF-9ABC-0080C7E7B78D}#1.0#0"; "mswinsck.ocx"
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "mscomctl.ocx"
Begin VB.Form frmServidor 
   Caption         =   "Form1"
   ClientHeight    =   3720
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   8190
   LinkTopic       =   "Form1"
   ScaleHeight     =   3720
   ScaleWidth      =   8190
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdSair 
      Caption         =   "Sair"
      Height          =   435
      Left            =   6840
      TabIndex        =   2
      Top             =   570
      Width           =   1335
   End
   Begin VB.CommandButton cmdMensagem 
      Caption         =   "Mensagem"
      Height          =   435
      Left            =   6840
      TabIndex        =   1
      Top             =   60
      Width           =   1335
   End
   Begin MSComctlLib.ListView lvwGrid 
      Height          =   3735
      Left            =   -30
      TabIndex        =   0
      Top             =   -30
      Width           =   6825
      _ExtentX        =   12039
      _ExtentY        =   6588
      View            =   3
      LabelEdit       =   1
      LabelWrap       =   -1  'True
      HideSelection   =   0   'False
      FullRowSelect   =   -1  'True
      GridLines       =   -1  'True
      _Version        =   393217
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      BorderStyle     =   1
      Appearance      =   1
      NumItems        =   0
   End
   Begin MSWinsockLib.Winsock wskConexao 
      Index           =   0
      Left            =   7770
      Top             =   3300
      _ExtentX        =   741
      _ExtentY        =   741
      _Version        =   393216
   End
End
Attribute VB_Name = "frmServidor"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'Types
Private Type typVetor
    ipCliente As String 'IP do cliente
    dtConexao As Date 'Data e Hora de conexo
End Type

'Constantes
Private Const maxConexao As Integer = 10 'Nmero mximo de conexes aceitas
Private Const formatoDataHora As String = "dd/mm/yyyy hh:mm:ss" 'Formato de data e hora

'Variveis
Private vetConexao() As typVetor 'Vetor que ser armazenado as informaes do cliente logado no servidor

Private Sub cmdMensagem_Click()
    Dim msg As String
    Dim i As Integer
    
    'Recebe a mensagem que os clientes devem receber
    msg = InputBox("Digite a mensagem que ser mostrada aos clientes logados", "Mensagem")
    If (Trim(msg) <> "") Then
        'Manda a mensagem para todos os clientes que tiverem conectados com o servidor
        For i = 1 To maxConexao
            With wskConexao(i)
                'Verifica se a instncia est conectada
                If (.State = sckConnected) Then
                    'Manda a mensagem para o cliente
                    'Formato do protocolo de comunicao que estou utilizando  a seguinte:
                    '<cdigo da ao>
                    '<separador> Estou utilizando como separador o ~
                    '<mensagem que ser mostrado para o cliente>
                    'O cliente dever interpretar esta mesma configurao do protocolo de comunicao
                    .SendData "1~" & msg
                End If
            End With
        Next i
    End If
End Sub

Private Sub cmdSair_Click()
    'Fecha o programa
    Unload Me
End Sub

Private Sub Form_Load()
    Dim i As Integer
    
    'Configura a grid
    iniciaGrid
    'Carrega a quantidade de instncias do winsock necessrias
    'Ou seja, poder existir maxConexo de clientes logados no servidor
    For i = 1 To maxConexao
        Load wskConexao(i)
    Next i
    'Carrega o vetor
    ReDim vetConexao(maxConexao)
    'Prepara o item (0) do winsock para ser o 'ouvido'
    'No servidor h a necessidade de existir uma instncia do winsock que ficar
    'esperando uma comunicao dos clientes. O que simboliza este 'ouvido'  a
    'propriedade .Listen
    With wskConexao(0)
        .LocalPort = 20001 'Porta de conexo onde o servidor ficar esperando uma comunicao
        .Listen 'informa que esta instncia  o 'ouvido'
    End With
End Sub

Private Sub wskConexao_Close(Index As Integer)
    'Fecha uma conexo
    fechaConexao Index
    wskConexao(Index).Close
End Sub

Private Sub wskConexao_ConnectionRequest(Index As Integer, ByVal requestID As Long)
    'Aceita a conexo do cliente
    Dim i As Integer
    
    'Verifica qual a primeira instncia livre para receber a conexo pedida
    For i = 1 To maxConexao
        With wskConexao(i)
            If (.State = sckClosed) Then
                .LocalPort = 0
                .Accept requestID 'Aceita a conexo para esta instncia
                vetConexao(i).ipCliente = .RemoteHostIP
                vetConexao(i).dtConexao = Now()
                atualizaGrid i 'Atuaiza os dados dos clientes logados na grid
                Exit For
            End If
        End With
    Next i
End Sub

Private Sub iniciaGrid()
    'Configurao inicial da grid
    Dim i As Integer
    
    With lvwGrid
        .ColumnHeaders.Add , , "IP do Cliente"
        .ColumnHeaders(.ColumnHeaders.Count).Width = 3400
        .ColumnHeaders.Add , , "Data de Conexo"
        .ColumnHeaders(.ColumnHeaders.Count).Width = 3400
        For i = 1 To maxConexao
            .ListItems.Add , , ""
            .ListItems(.ListItems.Count).ListSubItems.Add , , ""
        Next i
    End With
End Sub

Private Sub atualizaGrid(ByRef pos As Integer)
    'Atualiza os dados na posio indicada
    preencheGrid pos, vetConexao(pos).ipCliente, vetConexao(pos).dtConexao
End Sub

Private Sub fechaConexao(ByRef pos As Integer)
    'Limpa os dados na posio indicada
    preencheGrid pos, "", Empty
End Sub

Private Sub preencheGrid(ByRef pos As Integer, _
                         ByRef IP As String, _
                         ByRef dt As Date)
    'Preenche uma linha na grid
    If (pos > 0) Then
        With lvwGrid.ListItems(pos)
            .Text = IP
            If (dt <> "00:00:00") Then
                .ListSubItems(1).Text = Format(dt, formatoDataHora)
            Else
                .ListSubItems(1).Text = ""
            End If
        End With
        lvwGrid.Refresh
    End If
End Sub
